---
title: ServiceWorkerContainer.startMessages()
slug: Web/API/ServiceWorkerContainer/startMessages
tags:
  - API
  - Experimental
  - Reference
  - Service Workers
  - ServiceWorkerContainer
  - startMessages
---
<div>{{APIRef("Service Workers API")}}</div>

<p><span class="seoSummary">The <strong><code>startMessages()</code></strong> method of the {{domxref("ServiceWorkerContainer")}} interface explicitly starts the flow of messages being dispatched from a service worker to pages under its control (e.g. sent via {{domxref("Client.postMessage()")}}). This can be used to react to sent messages earlier, even before that page's content has finished loading.</span></p>

<h2 id="Explanation">Explanation</h2>

<p>By default, all messages sent from a page's controlling service worker to the page (using {{domxref("Client.postMessage()")}}) are queued while the page is loading, and get dispatched once the page's HTML document has been loaded and parsed (i.e. after the {{event("DOMContentLoaded")}} event fires). It's possible to start dispatching these messages earlier by calling {{domxref("ServiceWorkerContainer.startMessages()")}}, for example if you've invoked a message handler using {{domxref("EventTarget.addEventListener()")}} before the page has finished loading, but want to start processing the messages right away.</p>

<div class="notecard note">
<p><strong>Note</strong>: The messages start being sent automatically when setting the handler directly using {{domxref("ServiceWorkerContainer.onmessage")}}. In this you don't need <code>startMessages()</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>serviceWorkerContainer</em>.startMessages();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">if('serviceWorker' in navigator) {
  navigator.serviceWorker
           .register('/sw.js')
           .then(function() { console.log('Service Worker Registered'); });
}

// ...

navigator.serviceWorker.addEventListener('message', (e) =&gt; {
  // ...
});

navigator.serviceWorker.startMessages();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-serviceworkercontainer-startmessages', 'ServiceWorkerContainer: startMessages()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ServiceWorkerContainer.startMessages")}}</p>
</div>
